/*
** Copyright 2002-2006 KVASER AB, Sweden.  All rights reserved.
*/

/*
 * Kvaser Linux Canlib
 * Test set bus parameters
 */


#include <canlib.h>
#include <stdio.h>

void check(char* id, canStatus stat)
{
    char buf[50];

    buf[0] = '\0';
    canGetErrorText(stat, buf, sizeof(buf));
    if (stat != canOK) printf("%s: failed, stat=%d (%s)\n", id, (int)stat, buf);
    else printf("%s: OK\n", id);
    return;
}


/* Set bus parameters and read them back 10000 times */

int main (int argc, char *argv[])

{
    long freq;
    int tseg1, tseg2, sjw, noSamp, syncmode;
    int ret = -1;
    int i, j;
    canHandle h;
  
    h = canOpenChannel(j, canWANT_EXCLUSIVE | canWANT_EXTENDED);
    if (h < 0) {
    printf("canOpenChannel (%d) failed\n", j);
    return -1;
    }
    ret = canSetBusParams(h, BAUD_500K, 4, 3, 1, 1, 0);
    check("canSetBusParams", ret);
    ret = canBusOn(h);
    check("canBusOn", ret);

    canBusOff(h);
    canClose(h);


    return 0;
}



